// helpDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "string.h"
#include "mandelbrot.h"
#include "helpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ChelpDlg _CAO


ChelpDlg::ChelpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ChelpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ChelpDlg)
	m_str = _T("");
	//}}AFX_DATA_INIT
}


ChelpDlg::ChelpDlg(CFormView* pView) :CDialog()
{
  m_pView = pView;   
}


BOOL ChelpDlg::Create()
{
	return CDialog::Create(IDD_DIALOG1);
}

void ChelpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ChelpDlg)
	DDX_Text(pDX, IDC_HLPMSG, m_str);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ChelpDlg, CDialog)
	//{{AFX_MSG_MAP(ChelpDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ChelpDlg bZ[W nh

BOOL ChelpDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

  char buf[][80] = {
    "=====================================================================\r\n",
    "@@@@@@@@@@MUmandel 蔲wv                            \r\n",
    "=====================================================================\r\n",
    "                                            12Apr.'98 Tasyo Koji     \r\n",
    "                                            tasyo@muf.biglobe.ne.jp  \r\n",
    "                                                                     \r\n",
    "-------------------------------------------------------------------- \r\n",
    "@\E                                                         \r\n",
    "                                                                     \r\n",
    "1. }fu[W̐}e̐Fŕ\܂BVisual C++      \r\n",
    " @R[h܂̂ōłB                                  \r\n",
    "                                                                     \r\n",
    "2. Win95/NTΉłB͒Iɍs܂B                        \r\n",
    "                                                                     \r\n",
    "3. łi`撆łj`悳ĂCӂ̗̈}EXőI  \r\n",
    " @Ċgł܂B(`̊܂Ƀ}EXŊgł܂)      \r\n",
    "                                                                     \r\n",
    "4. Q{Ɋg傷{^Aɏk{^pӂ܂B        \r\n",
    "   ̃{^`̊҂ɂł܂B            \r\n",
    "                                                                     \r\n",
    "5.@ĝƂɂ͊ɕ`悳ꂽ}̃rbg}bv܂CɊg傳@ \r\n",
    "@ ܂Bɂ𐸖ĂȂ悤ɕ`悪i݂܂B          \r\n",
    "                                                                     \r\n",
    "6.i}EXpɁjlŕ`悷W͂ł܂B             \r\n",
    "                                                                     \r\n",
    "7.@`̐FUʂ̒炢łIł܂B@@@           \r\n",
    "                                                                     \r\n",
    "-------------------------------------------------------------------- \r\n",
    "}EXł̊g̈̎w@@                                     \r\n",
    "                                                                     \r\n",
    "  ̂Q̕@Ń}EXŕ`悳ꂽ}`̔Cӂ̕gł܂B \r\n",
    "                                                                     \r\n",
    "  (A) g傳SӏVONbN邱ƂłPO{Ɋg   \r\n",
    "      @B@@@@@@@                                       \r\n",
    "  (B) g傳̈}EXőIĎw肷@B               \r\n",
    "                                                                     \r\n",
    "  (A)̕@͎̂悤ɂ܂B                                      \r\n",
    "  }EX̃J[\i{^Ɂjg債Sӏɂ     \r\n",
    "@ĂA{^u`ƃNbN܂BƂ̃{^   \r\n",
    "  W𒆐SƂĂPO{Ɋg\܂B               \r\n",
    "                                                                     \r\n",
    "  (B)̕@͎̂悤ɂ܂B                                      \r\n",
    "  (1)i}EX̃{^Ɂj`悳ꂽ}`̊g債  @\r\n",
    "       ̓_܂Ń}EXړ܂B                            \r\n",
    "                                                                     \r\n",
    "  (2) }EX̍{^Ă̂܂܊g債̉E̓_܂   \r\n",
    "      [ƈړ܂Bg傳\̗͔̈]\܂B \r\n",
    "                                                                     \r\n",
    "  (3) }EX̍{^𗣂܂BƈCɍrg\Ă   \r\n",
    "      ̂ƁA𐸖ĂȂ悤ɕ`悪i݂܂B           \r\n",
    "                                                                     \r\n",
    "  ӁF                                                             \r\n",
    "    (*1)g傳̈̏c̔䗦͑̔䗦ƓB]ĉ   \r\n",
    "      Ƀ}EX𓮂ŏc̍Iɕω܂B       \r\n",
    "    (*2)@(B)ł̊gł͊gӏ͍ŏɍ̓_AɉE̓_    \r\n",
    "       ̏Ƀ}EXړĉBԈĂǂ\ꂽ    \r\n",
    "       킩ȂȂꍇ͏k{^AS̕\{^    \r\n",
    "       ĉB                                                \r\n",
    "    (*3)}EXł̊g\ł͕@(A)ƕ@(B)̃vOł   \r\n",
    "       ʂ͍{^Ă痣܂ł̎ԂōsĂ܂B@\r\n",
    "       āA߂̃VONbNł͕@(B)Ɖ߂܂(  \r\n",
    "       ꍇɒ[ɋ̈悪g傳܂̂Ńx^ʂɂȂꍇ  \r\n",
    "       ܂B͈̎xAS̕\k{^ĉB)     \r\n",
    "    (*4)gxƂbot̕_̐x̌Eȏɂ   \r\n",
    "       Đ}`rČ鎖܂BoOł͂܂B      \r\n",
    "-------------------------------------------------------------------- \r\n",
    "                                                                     \r\n",
    "̑                                                             \r\n",
    "1. Y̍W͏オ}CiXƂȂĂ܂B                       \r\n",
    "2. }EXł̊g(A)̕@̏ꍇ(B)̏ꍇ̂悤Ȃ܂ŕ\@\r\n",
    "   Ă}`CɍrL΂͂܂BR͉ʂ̋@\r\n",
    "   ̉ӏIꍇɈL΂ƂłȂ߂łB          \r\n",
    "-------------------------------------------------------------------- \r\n",
    "                                                                     \r\n",
    "ACXg[̕@@                                           \r\n",
    " st@C MUmandel1.exe 폜邾łB                   \r\n",
    "                                                                     \r\n",
    "-------------------------------------------------------------------- \r\n",
    "                                                                     \r\n",
    "쌠ȂǂɂāB                                               \r\n",
    "                                                                     \r\n",
    "1.{vO͂ǂȂłȂĉłRɖłg       \r\n",
    "@܂B                                                     \r\n",
    "                                                                     \r\n",
    "2.쌠͕Ă܂񂪁A]ڂ͎RłB]ڎɂ͂ł     \r\n",
    "@OɘAƋ@\Abv^oOΉo[Wƍ     \r\n",
    "  ł邩m܂iA͋`ł͂܂jB             \r\n",
    "                                                                     \r\n",
    "  AFtasyo@muf.biglobe.ne.jp  ܂ tasyo@synergetech.co.jp    \r\n",                             
    "                                                                     \r\n",
    "3.oO듮̓vO쐬҂̗ǐSɊÂĂł邩         \r\n",
    "@܂A@IȐӔC܂ł͂Ă܂B                       \r\n",
    "                                                                     \r\n",
    "4.\[XR[h͊]҂ΌJ܂B                     \r\n",
    "                                                                     \r\n",
    "y͂̕܂łłBz                                         \r\n",

/*
----------------------------------------------------------------------
@\ǉ\
  ( )
@( )̓o^^QƂ\Ȃ悤ɂB
  ( )mandelbrot ̑ɃWAWȂǂIĕ\ł
  @@悤ɂB
  ( )s̑xwł悤ɂBi񐔂̏ݒj
  ( )[Xo[W쐬B

----------------------------------------------------------------------
̐
j[256FIꍇ͎̂悤ȏĂ܂B
(1)܂ł̔񐔂256ƂĂ̂ 0..255܂ł̒l
   e_œB
(2) 255ʂA8bit 
@@rrr gg bbb 
   ̂悤ȃrbgɊ蓖ĂiE[ LSB)B
(3)
    rrr gg bbb@ƂrbgƂ݂Ă̂悤 24bitɎʑB

	bbbBBBBB ggGGGGGG rrrRRRRR <--- COLORDEF ̒l̃rbg\

----------------------------------------------------------------------

1998.4.4
̃wvt@C\p悤ɂB
lōW͂邽߂̃_CAO쐬B
^CgɁuvƂ񂪕\̂łB

PXXWNRQ6iؗjj
OɃbZ[W|vŃCtQ[̃vO
  Visual C++ ŏBx͖{̃}`Xbh̃vO
  ړIł mandelbrot 쐬ĂB
leb̃[J[Xbhŕ`揈sAj[Ȃǂ
@CXbĥpƂBfthXbh
@悭łȂ̂Ń[J[XbhpB
[J[Xbhŉʂɕ`悵悤ƂƁAAT[V
@ēVB͂{́@fthXbhpׂB
^_
@(1)Xbh֐́@calc()@̒ delete p ; ^[
@@@OɍsƎs̃G[ƂȂBȂH
@\
  (o)}EXŊg̈IłɂB
  (o)W̎w@ύXBlp̗̈̍WŎw肷@߂
  @@SWƏc̑Ŝ̕w肷@ɕύXB
  (o)S̐}`\A}EXŊgGAwł悤
  @@B

y܂Łz
*/
    "",NULL,

  };
  //CString str = "n";
  //CEdit *edit = (CEdit *)GetDlgItem(IDC_HELPMSG);
  //edit->SetWindowText(str);

  for (int i = 0; strlen(buf[i] ); i++)
    m_str = m_str + buf[i];

  UpdateData(FALSE);
	return TRUE;
}


