// mandelbrotView.cpp : CMandelbrotView NX̓̒`s܂B
//

#include "stdafx.h"
#include "mandelbrot.h"

#include "mandelbrotDoc.h"
#include "mandelbrotView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


typedef struct tagTHREADPARAMS{
  CWnd *pWnd;
  BOOL quit;
  double x1, y1, x_step, y_step;
  int    n_x, n_y;
  int  draw_type;
} THREADPARAMS;

THREADPARAMS m_thread;

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView

IMPLEMENT_DYNCREATE(CMandelbrotView, CFormView)

BEGIN_MESSAGE_MAP(CMandelbrotView, CFormView)
	//{{AFX_MSG_MAP(CMandelbrotView)
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_SETTING, OnSetting)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView NX̍\z/

CMandelbrotView::CMandelbrotView()
	: CFormView(CMandelbrotView::IDD)
{
	//{{AFX_DATA_INIT(CMandelbrotView)
		// : ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

CMandelbrotView::~CMandelbrotView()
{
}

void CMandelbrotView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMandelbrotView)
		// : ClassWizard ͂̈ʒu DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BOOL CMandelbrotView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
  m_quit = FALSE;  
  x1 = 0.2691; y1 = 0.0043;
  x_step = y_step = 0.000002;

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView NX̐ff

#ifdef _DEBUG
void CMandelbrotView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMandelbrotView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMandelbrotDoc* CMandelbrotView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMandelbrotDoc)));
	return (CMandelbrotDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView NX̃bZ[W nh
void CMandelbrotView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
  CWnd *h = GetDlgItem(IDC_PICT);	
  CRect r;
  h->GetClientRect(r);
  n_x = r.right; n_y = r.bottom;
/*
  ((CComboBox *)(GetDlgItem(IDC_STEP)))->SetCurSel(2);

  CDC *hDC;
  hDC=h->GetDC();
  memDC.CreateCompatibleDC(hDC);
  hbit.CreateCompatibleBitmap(hDC, r.right, r.bottom);
  SelectObject(memDC, hbit);
  memBrush1.CreateSolidBrush(f_color);
  memBrush0.CreateSolidBrush(RGB(64, 64, 64));
  SelectObject(memDC, memBrush0);
  memDC.PatBlt(0, 0, r.right, r.bottom, PATCOPY);

  memPen0.CreatePen(PS_SOLID, 1, RGB(64, 64, 64));
  memPen1.CreatePen(PS_SOLID, 1, f_color);

  h->ReleaseDC(hDC);	
  */
}

void CMandelbrotView::OnQuit() 
{
  AfxGetMainWnd()->PostMessage(WM_CLOSE);
}

// W(x, y)@ɒl val ̓_łB
void mark_point(CWnd *wndh, int val, int x, int y)
{
#if 0
	CPaintDC dc(wndh); 

  CWnd *h = wndh->GetDlgItem(IDC_PICT);	
  CDC *pDC = h->GetDC();

  COLORREF color;
  //CBrush b, mb;

  int val2 = val % 255;
  color = RGB(val2, val2, val2);

  pDC->SetPixel(x, y, color);
#endif
#if 0
  // zʂ̕`
  CPen mp(PS_SOLID, 1, color);
  CBrush *mb_old = memDC.SelectObject(&mb);
  CPen   *mp_old = memDC.SelectObject(&mp);

  memDC.Rectangle(x * n_delta, y * n_delta, 
                 (x + 1)* n_delta-1, (y + 1)*n_delta-1);
#endif

  //pDC->SelectObject(b_old);
  //pDC->SelectObject(oldp);
  //memDC.SelectObject(mb_old);
  //memDC.SelectObject(mp_old);
#if 0
  h->ReleaseDC(pDC);
#endif
}

UINT calc(LPVOID pParam) 
{
  CWnd *h = CWnd::FromHandle((HWND)pParam);
  CPaintDC dc(h); 
  CDC *pDC = h->GetDC();

  //THREADPARAMS *p = (THREADPARAMS *) pParam;
  //CWnd *pWnd = CWnd::FromHandle((HWND)p->pWnd);
  //CWnd *pWnd = CWnd::FromHandle((HWND)pParam);
  //CWnd *h= pWnd->GetDlgItem(IDC_PICT);
	//CPaintDC dc(); 

  //CClientDC dc(pWnd);
  //CDC *pDC = h->GetDC();
  //pDC->Rectangle(10, 10, 50, 50);
  
  int  i, j, val;

  pDC->Rectangle(10, 10, 50, 50);

  double x, y, a, b, a2, b2;
  double x1, y1, x_step, y_step;
  int  count, n_min = 50, n_max = 255;
  int  n_x, n_y;
  x1 = p->x1; y1 = p->y1;
  x_step = p->x_step; y_step = p->y_step;
  n_x = p->n_x; n_y = p->n_y;


//  AfxGetApp()->DoWaitCursor(1);  
#if 0
  for (i = 0; i < n_x; i++){
    x = x1 + i * x_step;
    for (j = 0; j < n_y; j++){
      y = y1 + j * y_step;
      a = x; b = y; 
      a2 = a * a; b2 = b * b; count = 0;
      while ((a2 + b2 <= 4) && (count < n_max)){
        b = 2 * a * b + y; a = a2 - b2 + x;
        a2 = a * a; b2 = b * b; 
        count++;
        if (p->quit) return 0;
      }
      if (count > n_min){
        val = 255 * (count - n_min) / (n_max - n_min);
        //mark_point(wndh, val, i, j);
        //mark_point(val, i, j);
      }
    }
  }
#endif
//  AfxGetApp()->DoWaitCursor(0);  
  return 0;
}

void CMandelbrotView::OnSetting() 
{
  //m_thread.pWnd = AfxGetMainWnd()->m_hWnd;
  m_thread.quit = FALSE;
  m_thread.x1 = x1;
  m_thread.y1 = y1;
  m_thread.x_step = x_step;
  m_thread.y_step = y_step;
  m_thread.n_x = n_x; 
  m_thread.n_y = n_y;

  //CWinThread *pThread = AfxBeginThread(calc, &m_thread);
  CWinThread *pThread = AfxBeginThread(calc, GetDlgItem(IDC_PICT)->m_hWnd);
}

void CMandelbrotView::OnStop() 
{
  m_thread.quit = TRUE;	
}
